#include <iostream.h>
#include <fastgraf.h>
#include <dos.h>
#include "standard.h"
#include "kdfold.h"
#include "kdsrvr.h"


const int CLOCKVECT = 0x1C;

static void interrupt newhandler(...);     // our replacement handler
static void interrupt (*oldhandler)(...);  // ptr to default handler
int HotkeyServer::newtick;

void HotkeyServer::startup()
  {
  newtick=FALSE;
  oldhandler=getvect(CLOCKVECT);
  setvect(CLOCKVECT,newhandler);
  cout << "KEYDOWNSERVER: hooked timer interrupt...\n";
  }

void HotkeyServer::shutdown()
  {
  if (oldhandler)
	{
    setvect(CLOCKVECT,oldhandler);
    cout << "KEYDOWNSERVER: restored timer interrupt...\n";
	oldhandler = 0;
	}
  }

void HotkeyServer::check(Folder& fld)
  {
  if (newtick)
	{
    newtick=FALSE;
    fld.dispatch();
	}
  }

void interrupt newhandler(...)
  {
  HotkeyServer::newtick=TRUE;
  oldhandler(...); 
  }
